package com.example.only_for_trial;

import android.Manifest;
import android.app.Activity;
import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Build;
import android.provider.MediaStore;
import android.util.Base64;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Iterator;
import java.util.List;
import java.util.Random;
import com.accurascan.ocr.mrz.model.BarcodeFormat;
import com.accurascan.ocr.mrz.model.ContryModel;
import com.accurascan.ocr.mrz.util.AccuraLog;
import com.androidnetworking.AndroidNetworking;
import com.docrecog.scan.MRZDocumentType;
import com.docrecog.scan.RecogEngine;
import com.docrecog.scan.RecogType;

import io.flutter.Log;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.plugin.common.PluginRegistry;

/** OnlyForTrialPlugin */
public class OnlyForTrialPlugin implements FlutterPlugin, MethodCallHandler,ActivityAware {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;
  public static Bitmap face1 = null;
  public static Bitmap face2 = null;
  private static Context appContext = null;
  private static Activity appActivity = null;
  public static Result onResult = null;
  public static JSONObject accuraErrorConfg;
  public static JSONObject accuraTitleMsg;
  public static JSONObject accuraConfigs;
  private String bType;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    appContext = flutterPluginBinding.getApplicationContext();
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "only_for_trial");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    try {



      String JSON_STRING = call.argument("arguments");
      JSONArray args = (new JSONArray(JSON_STRING));
//      JSONObject accuraConf = args.getJSONObject(0);

      if (call.method.equals("getPlatformVersion")) {
        result.success("Android " + android.os.Build.VERSION.RELEASE);
      } else if (call.method.equals("getMetaData")) {
        getMetaData(args,result);
      } else if (call.method.equals("startMRZ")){
        startMRZ(args,result);
      } else if (call.method.equals("startOcrWithCard")){
        startOcrWithCard(args,result);
      } else if (call.method.equals("startBankCard")){
        startBankCard(args,result);
      } else if (call.method.equals("startFaceMatch")){
        startFaceMatch(args,result);
      } else if (call.method.equals("startLiveness")){
        startLiveness(args,result);
      } else if (call.method.equals("startBarcode")){
        startBarcode(args,result);
      } else if (call.method.equals("getGallery1")){
        openGallery(args,result);
      } else if (call.method.equals("getGallery2")){
        openGallery2(args,result);
      } else if (call.method.equals("getCamera1")){
        startCamera(args,result);
      } else if (call.method.equals("getCamera2")){
        startCamera2(args,result);
      }
      else {
        result.notImplemented();
      }
    }catch (JSONException e){
      e.printStackTrace();
    }
  }

  public void getMetaData(JSONArray args, Result result) throws JSONException {
    Log.i("Inside meta data","Inside meta data");
    JSONObject results = new JSONObject();
    RecogEngine recogEngine = new RecogEngine();
    RecogEngine.SDKModel sdkModel = recogEngine.initEngine(appContext);
    if (sdkModel.i >= 0){
      AndroidNetworking.initialize(appContext, UnsafeOkHttpClient.getUnsafeOkHttpClient());
      accuraConfigs = args.getJSONObject(0);
      accuraErrorConfg = args.getJSONObject(1);
      accuraTitleMsg = args.getJSONObject(2);
      Log.i("gvghvhnb",accuraErrorConfg.getString("setCameraFrame"));
      if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && !isPermissionsGranted(appActivity)) {
        requestCameraPermission();
      }
      results.put("isValid", true);
      if(sdkModel.isOCREnable){
        results.put("isOCREnable", true);
        List<ContryModel> modelList = recogEngine.getCardList(appActivity);
        JSONArray countries = new JSONArray();
        for (int i = 0; i < modelList.size();i++){
          JSONObject country = new JSONObject();
          country.put("name",modelList.get(i).getCountry_name());
          country.put("id",modelList.get(i).getCountry_id());
          JSONArray cards = new JSONArray();
          List<ContryModel.CardModel> cardList = modelList.get(i).getCards();
          for (int j = 0; j < cardList.size(); j++) {
            JSONObject card = new JSONObject();
            card.put("name", cardList.get(j).getCard_name());
            card.put("id", cardList.get(j).getCard_id());
            card.put("type", cardList.get(j).getCard_type());
            cards.put(card);
          }
          country.put("cards",cards);
          countries.put(country);
        }
        results.put("countryList", countries);

        if (accuraConfigs.has("setFaceBlurPercentage")){
          recogEngine.setFaceBlurPercentage(appActivity, accuraConfigs.getInt("setFaceBlurPercentage"));
        }else{
          recogEngine.setFaceBlurPercentage(appActivity,70);
        }
        if (accuraConfigs.has("setHologramDetection")){
          recogEngine.SetHologramDetection(appActivity,accuraConfigs.getBoolean("setHologramDetection"));
        }else {
          recogEngine.SetHologramDetection(appActivity,true);
        }
        if (accuraConfigs.has("setLowLightTolerance")){
          recogEngine.setLowLightTolerance(appActivity,accuraConfigs.getInt("setLowLightTolerance"));
        }else {
          recogEngine.setLowLightTolerance(appActivity,39);
        }if (accuraConfigs.has("setMotionThreshold")){
          recogEngine.setMotionThreshold(appActivity,accuraConfigs.getInt("setMotionThreshold"));
        }else {
          recogEngine.setMotionThreshold(appActivity,18);
        }if (accuraConfigs.has("setMinGlarePercentage") &&
                accuraConfigs.has("setMaxGlarePercentage")){
          recogEngine.setGlarePercentage(appActivity,accuraConfigs.getInt("setMinGlarePercentage"),
                  accuraConfigs.getInt("setMaxGlarePercentage") );
        }else {
          recogEngine.setGlarePercentage(appActivity,6,98);
        } if (accuraConfigs.has("setBlurPercentage")){
          recogEngine.setBlurPercentage(appActivity, accuraConfigs.getInt("setBlurPercentage"));
        } else {
          recogEngine.setBlurPercentage(appActivity, 62);
        }
        recogEngine.isCheckPhotoCopy(appActivity,accuraConfigs.getBoolean("isCheckPhotoCopy"));
      }else{
        results.put("isOCREnable", false);
      }
      results.put("isMRZEnable", sdkModel.isMRZEnable);
      if (sdkModel.isAllBarcodeEnable){
        results.put("isBarcodeEnable", sdkModel.isAllBarcodeEnable);
        JSONArray barcodes = new JSONArray();

        barcodes.put(0,"ALL FORMATS");
        barcodes.put(1,"EAN-8");
        barcodes.put(2,"EAN-13");
        barcodes.put(3,"PDF417");
        barcodes.put(4,"AZTEC");
        barcodes.put(5,"CODE 128");
        barcodes.put(6,"CODE 93");
        barcodes.put(7,"CODE 39");
        barcodes.put(8,"DATA MATRIX");
        barcodes.put(9,"QR CODE");
        barcodes.put(10,"UPC-E");
        barcodes.put(11,"UPC-A");
        barcodes.put(12,"CODABAR");

        results.put("barcodes",barcodes);
      }
      else {
        results.put("isBarcodeEnable", sdkModel.isAllBarcodeEnable);

      }
      results.put("isBankCardEnable", sdkModel.isBankCardEnable);


    }else {
      results.put("isValid", false);
    }

    result.success(results.toString());
    return;
  }

  public void startMRZ(JSONArray args, Result result) throws JSONException {
    onResult = result;
    String mrzType = args.getString(1);
    Intent intent = new Intent(appActivity,OcrActivity.class);
    RecogType.MRZ.attachTo(intent);
    OcrActivity.recogType = RecogType.MRZ;
    if (mrzType.equals("passport_mrz")) {
      MRZDocumentType.PASSPORT_MRZ.attachTo(intent);
    }else if (mrzType.equals("id_mrz")){
      MRZDocumentType.ID_CARD_MRZ.attachTo(intent);
    }else if (mrzType.equals("visa_mrz")){
      MRZDocumentType.VISA_MRZ.attachTo(intent);
    }else{
      MRZDocumentType.NONE.attachTo(intent);
    }
    OcrActivity.accuraErrorConfg = accuraErrorConfg;
    OcrActivity.accuraTitleMsg = accuraTitleMsg;
    intent.putExtra("card_name",mrzType);
    intent.putExtra("app_orientation",appActivity.getRequestedOrientation());

    appActivity.startActivity(intent);

    return;
  }

  public void startBankCard(JSONArray args,Result result) throws JSONException{
    onResult = result;
    OcrActivity.accuraErrorConfg = accuraErrorConfg;
    OcrActivity.accuraTitleMsg = accuraTitleMsg;

    Intent intent = new Intent(appActivity,OcrActivity.class);
    intent.putExtra("card_name","Bank Card");
    intent.putExtra("app_orientation",appActivity.getRequestedOrientation());

    RecogType.BANKCARD.attachTo(intent);
    OcrActivity.recogType = RecogType.BANKCARD;

    appActivity.startActivity(intent);

    return;
  }

  public void startFaceMatch(JSONArray arg,Result result) throws JSONException{
    onResult = result;

    JSONObject uriL = arg.getJSONObject(0);
    String uri = uriL.getString("face_uri");
    OcrResultActivity.face1 = BitmapFactory.decodeFile(uri.replace("file://",""));
    OcrResultActivity.which = 0;
    OcrResultActivity.faceConfig = arg.getJSONObject(1);
    Intent intent = new Intent(appActivity,OcrResultActivity.class);
    appActivity.startActivity(intent);

  }

  public void startLiveness(JSONArray arg,Result result)throws JSONException{
    onResult = result;

    JSONObject uriL = arg.getJSONObject(0);
    String uri = uriL.getString("face_uri");
    OcrResultActivity.face1 = BitmapFactory.decodeFile(uri.replace("file://",""));
    OcrResultActivity.which = 1;
    OcrResultActivity.livenessConfig = arg.getJSONObject(1);
    Intent intent = new Intent(appActivity,OcrResultActivity.class);
    appActivity.startActivity(intent);

  }

  public void startBarcode(JSONArray args,Result result)throws JSONException{

    onResult = result;
    bType = args.getString(0);
    OcrActivity.accuraErrorConfg = accuraErrorConfg;
    OcrActivity.accuraTitleMsg = accuraTitleMsg;
    OcrActivity.barcodeFormat = getBarcodeFormat(bType);
    OcrActivity.recogType = RecogType.BARCODE;
    Intent intent = new Intent(appActivity,OcrActivity.class);
    RecogType.BARCODE.attachTo(intent);
    appActivity.startActivity(intent);

  }

  public void startOcrWithCard(JSONArray args, Result result) throws JSONException{
    onResult = result;
    OcrActivity.accuraErrorConfg = accuraErrorConfg;
    OcrActivity.accuraTitleMsg = accuraTitleMsg;

    int countryId = args.getInt(1);
    int cardId = args.getInt(2);
    String cardSelected = args.getString(3);
    int cardType = args.getInt(4);

    Intent intent = new Intent(appActivity,OcrActivity.class);
    intent.putExtra("country_id",countryId);
    intent.putExtra("card_id",cardId);
    intent.putExtra("card_name",cardSelected);

    if (cardType == 1){
      RecogType.PDF417.attachTo(intent);
      OcrActivity.recogType = RecogType.PDF417;
    }
    else if (cardType == 2) {
      RecogType.DL_PLATE.attachTo(intent);
      OcrActivity.recogType = RecogType.DL_PLATE;
    }
    else {
      RecogType.OCR.attachTo(intent);
      OcrActivity.recogType = RecogType.OCR;
    }

    appActivity.startActivity(intent);

    return;
  }


  public void startCamera(JSONArray args, Result result) throws JSONException {

    onResult = result;
    ActivityFaceMatch.No = 1;
    ActivityFaceMatch.which = 1;
    JSONObject accuraConf = args.getJSONObject(0);
    ActivityFaceMatch.faceMatchConfig = args.getJSONObject(1);
    ActivityFaceMatch.sface = accuraConf.getString("face1");
    ActivityFaceMatch.mface = accuraConf.getString("face2");
//    JSONObject config = args.getJSONObject(1);
    Intent intent = new Intent(appActivity, ActivityFaceMatch.class);
//    intent = addDefaultConfigs(intent, accuraConf);
//    intent = addDefaultConfigs(intent, config);
    appActivity.startActivity(intent);
    return;
  }

  public void openGallery(JSONArray args, Result result) throws JSONException {

    onResult = result;
    ActivityFaceMatch.which = 2;
    ActivityFaceMatch.No = 1;
    JSONObject accuraConf = args.getJSONObject(0);
    ActivityFaceMatch.sface = accuraConf.getString("face1");
    ActivityFaceMatch.mface = accuraConf.getString("face2");
//    JSONObject config = args.getJSONObject(1);
    Intent intent = new Intent(appActivity, ActivityFaceMatch.class);
//    intent = addDefaultConfigs(intent, accuraConf);
//    intent = addDefaultConfigs(intent, config);
    appActivity.startActivity(intent);
    return;
  }

  public void openGallery2(JSONArray args, Result result) throws JSONException {

    onResult = result;
    ActivityFaceMatch.No = 2;
    ActivityFaceMatch.which = 4;
    JSONObject accuraConf = args.getJSONObject(0);
    ActivityFaceMatch.sface = accuraConf.getString("face1");
    ActivityFaceMatch.mface = accuraConf.getString("face2");
//    JSONObject config = args.getJSONObject(1);
    Intent intent = new Intent(appActivity, ActivityFaceMatch.class);
//    intent = ActivityFaceMatch(intent, accuraConf);
//    intent = addDefaultConfigs(intent, config);
    appActivity.startActivity(intent);
    return;
  }

  public void startCamera2(JSONArray args, Result result) throws JSONException {

    onResult = result;
    ActivityFaceMatch.which = 3;

    ActivityFaceMatch.No = 2;
    JSONObject accuraConf = args.getJSONObject(0);
    ActivityFaceMatch.faceMatchConfig = args.getJSONObject(1);
    ActivityFaceMatch.sface = accuraConf.getString("face1");
    ActivityFaceMatch.mface = accuraConf.getString("face2");
    Intent intent = new Intent(appActivity, ActivityFaceMatch.class);
    appActivity.startActivity(intent);
    return;
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  @Override
  public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
    appActivity = binding.getActivity();
  }

  @Override
  public void onDetachedFromActivity() {

  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {

  }

  @Override
  public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {

  }


  public int getBarcodeFormat(String barcode){
    int resultOf = 0;
    switch (bType) {
      case "ALL FORMATS":
        resultOf = 0;
        break;
      case "EAN-8":
        resultOf = 64;
        break;
      case "EAN-13":
        resultOf = 32;
        break;
      case "PDF417":
        resultOf = 2048;
        break;
      case "AZTEC":
        resultOf = 4096;
        break;
      case "CODE 128":
        resultOf = 1;
        break;
      case "CODE 93":
        resultOf = 4;
        break;
      case "CODE 39":
        resultOf = 2;
        break;
      case "DATA MATRIX":
        resultOf = 16;
        break;
      case "QR CODE":
        resultOf = 256;
        break;
      case "CODABAR":
        resultOf = 8;
        break;
      case "UPC-E":
        resultOf = 1024;
        break;
      case "UPC-A":
        resultOf = 512;
        break;
    }
    return resultOf;
  }

  public static String getSaltString() {
    String SALTCHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890";
    StringBuilder salt = new StringBuilder();
    Random rnd = new Random();
    while (salt.length() < 18) { // length of the random string.
      int index = (int) (rnd.nextFloat() * SALTCHARS.length());
      salt.append(SALTCHARS.charAt(index));
    }
    return salt.toString();
  }

  public static Bitmap getBitmap(ContentResolver cr, Uri url)
          throws FileNotFoundException, IOException {
    InputStream input = cr.openInputStream(url);
    Bitmap bitmap = BitmapFactory.decodeStream(input);
    input.close();
    return bitmap;
  }

  public static Bitmap getBase64ToBitmap(String base64Image) {

    byte[] decodedString = Base64.decode(base64Image, Base64.DEFAULT);
    Bitmap decodedByte = BitmapFactory.decodeByteArray(decodedString, 0, decodedString.length);
    return decodedByte;
  }

  public static String getImageUri(Bitmap bitmap, String name, String path) {
    OutputStream fOut = null;
    File file = new File(path, getSaltString() + "_" + name + ".jpg");
    try {
      fOut = new FileOutputStream(file);
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    }
    bitmap.compress(Bitmap.CompressFormat.JPEG, 100, fOut);
    try {
      fOut.flush(); // Not really required
      fOut.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
    return "file://"+file.getAbsolutePath();
  }

  public static boolean isPermissionsGranted(Context context) {
    String[] permissions = new String[]{Manifest.permission.CAMERA, Manifest.permission.WRITE_EXTERNAL_STORAGE};
    for (String permission : permissions) {
      if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M)
        if (ActivityCompat.checkSelfPermission(context, permission) != PackageManager.PERMISSION_GRANTED) {
          return false;
        }
    }
    return true;
  }

  //requesting the camera permission
  public void requestCameraPermission() {
    int currentapiVersion = Build.VERSION.SDK_INT;
    if (currentapiVersion >= Build.VERSION_CODES.M) {
      if (ActivityCompat.checkSelfPermission(appActivity, Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED
              || ActivityCompat.checkSelfPermission(appActivity, Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED) {
        if (ActivityCompat.shouldShowRequestPermissionRationale(appActivity, Manifest.permission.CAMERA)
                || ActivityCompat.shouldShowRequestPermissionRationale(appActivity, Manifest.permission.WRITE_EXTERNAL_STORAGE)) {
          appActivity.requestPermissions(new String[]{Manifest.permission.CAMERA, Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);
        } else {
          appActivity.requestPermissions(new String[]{Manifest.permission.CAMERA, Manifest.permission.WRITE_EXTERNAL_STORAGE}, 1);
        }
      }
    }
  }
}
