import 'dart:io';
import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:only_for_trial_example/FaceMatch.dart';
import 'package:only_for_trial_example/ocrScreen.dart';
import 'package:flutter/services.dart';
import 'package:path_provider/path_provider.dart';


void main() {
  runApp(MaterialApp(
    home: HomePage(),
    debugShowCheckedModeBanner: false,
  ));
}

class HomePage extends StatefulWidget {
  const HomePage({Key? key}) : super(key: key);

  @override
  State<HomePage> createState() => _HomePageState();
}

class _HomePageState extends State<HomePage> {
  @override
  void initState() {
    super.initState();
    _shareImage();
  }
  String file1 = "";
  String filePath = "";
  String file2 = "file://";

  _shareImage() async {
    try {
      final ByteData bytes = await rootBundle.load('assets/images/image.png');
      final Uint8List list = bytes.buffer.asUint8List();

      final tempDir = await getTemporaryDirectory();
      final file = await new File('${tempDir.path}/image.jpg').create();
      file.writeAsBytesSync(list);
      file1 = file.toString();
      String ggg = file1.replaceAll("File: '", "");
      String fff = ggg.replaceAll("'", "");
      filePath = file2 + fff;
      setState(() {

      });
    } catch (e) {
      print('Share error: $e');
    }
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: const Text("Accura KYC 3.0.1"),
        backgroundColor: Colors.red[800],
      ),
      body: Container(
          decoration: const BoxDecoration(
              image: DecorationImage(
                  image: AssetImage("assets/images/bg_home.png"),
                  fit: BoxFit.cover
              )
          ),
          child:SingleChildScrollView(
              child: Center(
                child: Column(
                  children: [
                    SizedBox(height: 30,),
                    GestureDetector(
                      onTap: (){
                        Navigator.push(context, MaterialPageRoute(builder: (context)=>MyApp()));
                      },
                      child: Container(
                        height: 300,
                        width: MediaQuery.of(context).size.width-50,
                        decoration: const BoxDecoration(
                          image: DecorationImage(
                            image: AssetImage("assets/images/OCR.jpg"),
                            // fit: BoxFit.cover,
                          ),
                        ),
                      ),
                    ),
                    GestureDetector(
                      child: Container(
                        height: 300,
                        width: MediaQuery.of(context).size.width-50,
                        decoration: const BoxDecoration(
                          image: DecorationImage(
                            image: AssetImage("assets/images/Facematch.jpg"),
                            // fit: BoxFit.cover,
                          ),
                        ),
                      ),
                      onTap: (){
                        Navigator.push(context, MaterialPageRoute(builder: (context)=>FaceMatch()));
                      },
                    )
                  ],
                ),
              )
          )
      ),
    );
  }
}
