import UIKit
import AccuraOCR
import Photos
import PhotosUI
import SVProgressHUD

class FMController: UIViewController, UIImagePickerControllerDelegate, UINavigationControllerDelegate,PHPickerViewControllerDelegate {
   
    

    var imagePicker = UIImagePickerController()
    var arrDocument: [UIImage] = [UIImage]()
    var selectFirstImage = false
    var facematch = Facematch()
    var liveness = Liveness()
    var gallery1 = false
    var gallery2 = false
    var faceMatch1 = false
    var facematch2 = false

    var faceArgs:NSDictionary = [:]
    var callBack: FlutterResult? = nil
    var reactViewController:UIViewController? = nil
    var audioPath: URL? = nil
    var isFacematchDone = false
    var isCalledCallBack = false
    
    func closeMe() {
        DispatchQueue.main.async {
            self.dismiss(animated: true) {}
        }
        
    }
    var win: UIWindow? = nil
    
    override var supportedInterfaceOrientations: UIInterfaceOrientationMask {
        
        return .portrait
    }

    override func viewDidLoad() {
        super.viewDidLoad()

        imagePicker.delegate = self
        
        if gallery1 {
            imageGallery1()
        } else if gallery2{
            imageGallery2()
        } else if faceMatch1 {
            imageCamera1()
        } else if facematch2 {
            imageCamera2()
        }
    }
    
    override func viewDidAppear(_ animated: Bool) {
        
        
    }
    
    override func viewWillAppear(_ animated: Bool) {
        facematch = Facematch.init()
        liveness = Liveness.init()
        liveness.setBlurPercentage(80)
        liveness.setGlarePercentage(-1,-1)
        facematch.setBackGroundColor("#C4C4C5")
        facematch.setCloseIconColor("#000000")
        facematch.setFeedbackBackGroundColor("#C4C4C5")
        facematch.setFeedbackTextColor("#000000")
        if faceArgs["setFeedbackTextSize"] != nil {
            facematch.setFeedbackTextSize((faceArgs["setFeedbackTextSize"] as? Float)!)
        }else{
            facematch.setFeedbackTextSize(Float(18.0))
        }
        if faceArgs["setFeedBackframeMessage"] != nil {
            facematch.setFeedBackframeMessage(faceArgs["setFeedBackframeMessage"] as! String)
        }else{
            facematch.setFeedBackframeMessage("Frame Your Face")
        }
        if faceArgs["setFeedBackAwayMessage"] != nil {
            facematch.setFeedBackAwayMessage(faceArgs["setFeedBackAwayMessage"] as! String)
        }else{
            facematch.setFeedBackAwayMessage("Move Phone Away")
        }
        if faceArgs["setFeedBackOpenEyesMessage"] != nil {
            facematch.setFeedBackOpenEyesMessage(faceArgs["setFeedBackOpenEyesMessage"] as! String)
        }else{
            facematch.setFeedBackOpenEyesMessage("Keep Open Your Eyes")

        }
        if faceArgs["setFeedBackCloserMessage"] != nil {
            facematch.setFeedBackCloserMessage(faceArgs["setFeedBackCloserMessage"] as! String)
        }else{
            facematch.setFeedBackCloserMessage("Move Phone Closer")
        }
        if faceArgs["setFeedBackCenterMessage"] != nil {
            facematch.setFeedBackCenterMessage(faceArgs["setFeedBackCenterMessage"] as! String)
        }else{
            facematch.setFeedBackCenterMessage("Center Your Face")
        }
        if faceArgs["setFeedbackMultipleFaceMessage"] != nil {
            facematch.setFeedbackMultipleFaceMessage(faceArgs["setFeedbackMultipleFaceMessage"] as! String)
        }else{
            facematch.setFeedbackMultipleFaceMessage("Multiple face detected")
        }
        if faceArgs["setFeedBackFaceSteadymessage"] != nil {
            facematch.setFeedBackFaceSteadymessage(faceArgs["setFeedBackFaceSteadymessage"] as! String)
        }else{
            facematch.setFeedBackFaceSteadymessage("Keep Your Head Straight")
        }
        if faceArgs["setFeedBackLowLightMessage"] != nil {
            facematch.setFeedBackFaceSteadymessage(faceArgs["setFeedBackLowLightMessage"] as! String)
        }else{
            facematch.setFeedBackLowLightMessage("Low light detected")
        }
        if faceArgs["setFeedBackBlurFaceMessage"] != nil {
            facematch.setFeedBackBlurFaceMessage(faceArgs["setFeedBackBlurFaceMessage"] as! String)
        }else{
            facematch.setFeedBackBlurFaceMessage("Blur detected over face")
        }
        if faceArgs["setFeedBackGlareFaceMessage"] != nil {
            facematch.setFeedBackGlareFaceMessage(faceArgs["setFeedBackGlareFaceMessage"] as! String)
        }else{
            facematch.setFeedBackGlareFaceMessage("Glare detected")
        }
        if faceArgs["setBlurPercentage"] != nil {
            facematch.setBlurPercentage(faceArgs["setBlurPercentage"] as! Int32)
        }else{
            facematch.setBlurPercentage(80)
        }
        if faceArgs["setGlarePercentage_0"] != nil && faceArgs["setGlarePercentage_1"] != nil {
            facematch.setGlarePercentage(faceArgs["setGlarePercentage_0"] as! Int32, faceArgs["setGlarePercentage_1"] as! Int32)
        }else{
            facematch.setGlarePercentage(-1, -1)
        }
        
        
    }
    
    @IBAction func baAtn(_ sender: UIButton) {
        closeMe()
    }
    
    func imageCamera1() {
        DispatchQueue.main.asyncAfter(deadline: .now(), execute: {
            self.facematch.setFacematch(self)
        })
        selectFirstImage = true

    }
    func imageGallery1() {
        self.openPhotosLibrary(_isFirst: true)
    }
    
    func imageCamera2() {
        DispatchQueue.main.asyncAfter(deadline: .now(), execute: {
            self.facematch.setFacematch(self)
            self.view.setNeedsLayout()
        })
        selectFirstImage = false

    }
    
    func imageGallery2() {
        self.openPhotosLibrary(_isFirst: false)
    }
    
    func openPhotosLibrary(_isFirst: Bool){
        let photos = PHPhotoLibrary.authorizationStatus()
        if photos == .denied {
            DispatchQueue.main.async {
                let alert = UIAlertController(title: "AccuraFrame", message: "It looks like your privacy settings are preventing us from accessing your Photos", preferredStyle: .alert);
                let defaultAction = UIAlertAction(title: "OK", style: .default) { _ in
                    if #available(iOS 10.0, *) {
                        UIApplication.shared.open(URL(string: UIApplication.openSettingsURLString)!, options: [:], completionHandler: nil)
                    } else {
                        UIApplication.shared.openURL(URL(string: UIApplication.openSettingsURLString)!)
                    }
                }
                alert.addAction(defaultAction)
                self.present(alert, animated: true, completion: nil)
            }
        }
        if photos == .denied || photos == .notDetermined{
            PHPhotoLibrary.requestAuthorization({status in
                if status == .authorized{
                    DispatchQueue.main.async {
                        self.openGallary(_isFirst)
                    }
                    
                }
            })
        }else if photos == .authorized{
            DispatchQueue.main.async {
                self.openGallary(_isFirst)
            }
        }
    }
    

    
    func openGallary(_ isFirst: Bool){
        if #available(iOS 14, *) {
            selectFirstImage = isFirst
                    var config = PHPickerConfiguration(photoLibrary: PHPhotoLibrary.shared())
                    config.selectionLimit = 1
                    config.filter = .images
                    config.preferredAssetRepresentationMode = .current
                    let picker = PHPickerViewController(configuration: config)
                    picker.delegate = self
                    self.present(picker, animated: true, completion: nil)
            
        } else {
            selectFirstImage = isFirst
            self.imagePicker.sourceType = .photoLibrary
            self.imagePicker.allowsEditing = false
            self.present(self.imagePicker, animated: true, completion: nil)
        }
        
    }
    
    @objc func loadPhotoCaptured() {
        let img = allImageViewsSubViews(imagePicker.viewControllers.first?.view)?.last
        if img != nil {
            if let imgView: UIImageView = img as? UIImageView{
                imagePickerController(imagePicker, didFinishPickingMediaWithInfo: convertToUIImagePickerControllerInfoKeyDictionary([convertFromUIImagePickerControllerInfoKey(UIImagePickerController.InfoKey.originalImage) : imgView.image!]))
            }
        } else {
            imagePicker.dismiss(animated: true)
        }
    }
    
    func allImageViewsSubViews(_ view: UIView?) -> [AnyHashable]? {
        var arrImageViews: [AnyHashable] = []
        if (view is UIImageView) {
            if let view = view {
                arrImageViews.append(view)
            }
        } else {
            for subview in view?.subviews ?? [] {
                if let all = allImageViewsSubViews(subview) {
                    arrImageViews.append(contentsOf: all)
                }
            }
        }
        return arrImageViews
    }
    
    
    func imagePickerController(_ picker: UIImagePickerController,
                               didFinishPickingMediaWithInfo info: [UIImagePickerController.InfoKey : Any]) {
        let info = convertFromUIImagePickerControllerInfoKeyDictionary(info)
        
        
        dismiss(animated: true, completion: nil)
        SVProgressHUD.show(withStatus: "Loading...")
        DispatchQueue.global(qos: .background).async {
            guard var originalImage = info[convertFromUIImagePickerControllerInfoKey(UIImagePickerController.InfoKey.originalImage)] as? UIImage else { return }
            
            
            let ratio = CGFloat(originalImage.size.width) / originalImage.size.height
            originalImage = self.compressimage(with: originalImage, convertTo: CGSize(width: 600 * ratio, height: 600))!
            
            let compressData = UIImage(data: originalImage.jpegData(compressionQuality: 1.0)!)
            DispatchQueue.main.asyncAfter(deadline: .now(), execute: {
                SVProgressHUD.dismiss()
            })
        }
        
    }
    
    @available(iOS 14, *)
    func picker(_ picker: PHPickerViewController, didFinishPicking results: [PHPickerResult]) {
        dismiss(animated: true, completion: nil)
        guard !results.isEmpty else { return }
        for result in results {
            result.itemProvider.loadObject(ofClass: UIImage.self, completionHandler: { (object, error) in
                if let image = object as? UIImage {
                    DispatchQueue.main.async { [self] in
                        let ratio = CGFloat(image.size.width) / image.size.height
                        let originalImage = self.compressimage(with: image, convertTo: CGSize(width: 600 * ratio, height: 600))!
                        
                        let compressData = UIImage(data: originalImage.jpegData(compressionQuality: 1.0)!)
                        gl.face1Detect = EngineWrapper.detectSourceFaces(compressData)
                        
                        SVProgressHUD.dismiss()
                        var result:[String:Any] = [:]
                        result["Image"] = compressData
                        if result.index(forKey: "Image") != nil {
                            let img1 = SwiftOnlyForTrialPlugin.getImageUri(img: compressData!, name: nil)
                            result["Image"] = img1
                            if(gl.No == 1){
                                gl.face1 = compressData
                                if gl.face1 != nil && gl.face2 != nil {
                                    gl.face1Detect = EngineWrapper.detectSourceFaces(gl.face1)
                                    gl.face2Detect = EngineWrapper.detectTargetFaces(gl.face2, feature1: gl.face1Detect?.feature)
                                    let fmSore = EngineWrapper.identify(gl.face1Detect?.feature, featurebuff2: gl.face2Detect?.feature)
                                    let twoDecimalPlaces = String(format: "%.2f", fmSore*100)//Match score Convert Float Value
                                    result["score"] = twoDecimalPlaces
                                }
                            }
                            if gl.No == 2 {
                                gl.face2 = compressData
                                if gl.face1 != nil && gl.face2 != nil {
                                    gl.face1Detect = EngineWrapper.detectSourceFaces(gl.face1)
                                    gl.face2Detect = EngineWrapper.detectTargetFaces(gl.face2, feature1: gl.face1Detect?.feature)
                                    let fmSore = EngineWrapper.identify(gl.face1Detect?.feature, featurebuff2: gl.face2Detect?.feature)
                                    let twoDecimalPlaces = String(format: "%.2f", fmSore*100)//Match score Convert Float Value
                                    result["score"] = twoDecimalPlaces
                                }
                            }
                            callBack!(SwiftOnlyForTrialPlugin.convertJSONString(results:result))
                            closeMe()
                        } else {
                            
                            callBack!(FlutterError.init(code: "101", message: "Error found in data. Please try again", details: nil))
                            closeMe()
                        }
                    }
                }
            })
        }
    }
    
    
    func facematchData(_ FaceImage: UIImage!) {
        SVProgressHUD.show(withStatus: "Loading...")
        DispatchQueue.global(qos: .background).async { [self] in
            var originalImage = FaceImage
            
            let ratio = CGFloat(FaceImage.size.width) / originalImage!.size.height
            originalImage = self.compressimage(with: originalImage, convertTo: CGSize(width: 600 * ratio, height: 600))!
            var result:[String:Any] = [:]
            let compressData = UIImage(data: FaceImage.jpegData(compressionQuality: 1.0)!)
            DispatchQueue.main.asyncAfter(deadline: .now(), execute: { [self] in
                SVProgressHUD.dismiss()
            })
            let img1 = SwiftOnlyForTrialPlugin.getImageUri(img: compressData!, name: nil)
            result["Image"] = img1
            if(gl.No == 1){
                gl.face1 = compressData
                if gl.face1 != nil && gl.face2 != nil {
                    gl.face1Detect = EngineWrapper.detectSourceFaces(gl.face1)
                    gl.face2Detect = EngineWrapper.detectTargetFaces(gl.face2, feature1: gl.face1Detect?.feature)
                    let fmSore = EngineWrapper.identify(gl.face1Detect?.feature, featurebuff2: gl.face2Detect?.feature)
                    let twoDecimalPlaces = String(format: "%.2f", fmSore*100)//Match score Convert Float Value
                    result["score"] = twoDecimalPlaces
                }
            }
            if gl.No == 2 {
                gl.face2 = compressData
                if gl.face1 != nil && gl.face2 != nil {
                    gl.face1Detect = EngineWrapper.detectSourceFaces(gl.face1)
                    gl.face2Detect = EngineWrapper.detectTargetFaces(gl.face2, feature1: gl.face1Detect?.feature)
                    let fmSore = EngineWrapper.identify(gl.face1Detect?.feature, featurebuff2: gl.face2Detect?.feature)
                    let twoDecimalPlaces = String(format: "%.2f", fmSore*100)//Match score Convert Float Value
                    result["score"] = twoDecimalPlaces
                    print(twoDecimalPlaces)
                }
                
            }
            callBack!(SwiftOnlyForTrialPlugin.convertJSONString(results:result))
            print(result)
            closeMe()
        }
    }
    
    func compressimage(with image: UIImage?, convertTo size: CGSize) -> UIImage? {
        UIGraphicsBeginImageContext(size)
        image?.draw(in: CGRect(x: 0, y: 0, width: size.width, height: size.height))
        let destImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        return destImage
    }
    fileprivate func convertFromUIImagePickerControllerInfoKeyDictionary(_ input: [UIImagePickerController.InfoKey: Any]) -> [String: Any] {
        return Dictionary(uniqueKeysWithValues: input.map {key, value in (key.rawValue, value)})
    }
    
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertToUIImagePickerControllerInfoKeyDictionary(_ input: [String: Any]) -> [UIImagePickerController.InfoKey: Any] {
    return Dictionary(uniqueKeysWithValues: input.map { key, value in (UIImagePickerController.InfoKey(rawValue: key), value)})
}

// Helper function inserted by Swift 4.2 migrator.
fileprivate func convertFromUIImagePickerControllerInfoKey(_ input: UIImagePickerController.InfoKey) -> String {
    return input.rawValue
}

extension UIImage {
    func resizeWithPercent(percentage: CGFloat) -> UIImage? {
        let imageView = UIImageView(frame: CGRect(origin: .zero, size: CGSize(width: size.width * percentage, height: size.height * percentage)))
        imageView.contentMode = .scaleAspectFit
        imageView.image = self
        UIGraphicsBeginImageContextWithOptions(imageView.bounds.size, false, scale)
        guard let context = UIGraphicsGetCurrentContext() else { return nil }
        imageView.layer.render(in: context)
        guard let result = UIGraphicsGetImageFromCurrentImageContext() else { return nil }
        UIGraphicsEndImageContext()
        return result
    }
    func resizeWithWidth(width: CGFloat, height:CGFloat) -> UIImage? {
        let imageView = UIImageView(frame: CGRect(origin: .zero, size: CGSize(width: width, height: height)))
        imageView.contentMode = .scaleAspectFit
        imageView.image = self
        UIGraphicsBeginImageContextWithOptions(imageView.bounds.size, false, scale)
        guard let context = UIGraphicsGetCurrentContext() else { return nil }
        imageView.layer.render(in: context)
        guard let result = UIGraphicsGetImageFromCurrentImageContext() else { return nil }
        UIGraphicsEndImageContext()
        return result
    }
    func resizeWithWidth(width: CGFloat) -> UIImage? {
        let imageView = UIImageView(frame: CGRect(origin: .zero, size: CGSize(width: width, height: CGFloat(ceil(width/size.width * size.height)))))
        imageView.contentMode = .scaleAspectFit
        imageView.image = self
        UIGraphicsBeginImageContextWithOptions(imageView.bounds.size, false, scale)
        guard let context = UIGraphicsGetCurrentContext() else { return nil }
        imageView.layer.render(in: context)
        guard let result = UIGraphicsGetImageFromCurrentImageContext() else { return nil }
        UIGraphicsEndImageContext()
        return result
    }
    
    
}

extension FMController: FacematchData{
    func facematchViewDisappear() {
    }


}
