import UIKit
import AccuraOCR

class LVController: UIViewController
{
    var callBack: FlutterResult? = nil
    var liveness = Liveness()
    var faceImage: UIImage?
    var faceRegion: NSFaceRegion?
    var reactViewController:UIViewController? = nil
    var isLiveness = false
    var livenessConfig:NSDictionary = [:]
    
    var facematch = Facematch()
    var isfacematch = false
    var faceArgs:NSDictionary = [:]

    func closeMe() {
        self.dismiss(animated: true) {}
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        if(!EngineWrapper.isEngineInit()) {
            EngineWrapper.faceEngineInit()
        }
    }

    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        if isLiveness{
        liveness.setBackGroundColor(livenessConfig["backGroundColor"] as! String)
        liveness.setCloseIconColor(livenessConfig["closeIconColor"] as! String)
        liveness.setFeedbackBackGroundColor(livenessConfig["feedbackBackGroundColor"] as! String)
        liveness.setFeedbackTextColor(livenessConfig["feedbackTextColor"] as! String)
        if livenessConfig["setLivenessURL"] != nil {
            print("\(livenessConfig["setLivenessURL"])")
            liveness.setLivenessURL(livenessConfig["setLivenessURL"] as! String)
        }
        if livenessConfig["setFeedbackTextSize"] != nil {
            liveness.setFeedbackTextSize((livenessConfig["setFeedbackTextSize"] as? Float)!)
        }else{
            liveness.setFeedbackTextSize(Float(18.0))
        }
        if livenessConfig["setFeedbackTextSize"] != nil {
            liveness.setFeedbackTextSize((livenessConfig["setFeedbackTextSize"] as? Float)!)
        }else{
            liveness.setFeedbackTextSize(Float(18.0))
        }
        if livenessConfig["setFeedBackframeMessage"] != nil {
            liveness.setFeedBackframeMessage(livenessConfig["setFeedBackframeMessage"] as! String)
        }else{
            liveness.setFeedBackframeMessage("Frame Your Face")
        }
        if livenessConfig["setFeedBackAwayMessage"] != nil {
            liveness.setFeedBackAwayMessage(livenessConfig["setFeedBackAwayMessage"] as! String)
        }else{
            liveness.setFeedBackAwayMessage("Move Phone Away")
        }
        if livenessConfig["setFeedBackOpenEyesMessage"] != nil {
            liveness.setFeedBackOpenEyesMessage(livenessConfig["setFeedBackOpenEyesMessage"] as! String)
        }else{
            liveness.setFeedBackOpenEyesMessage("Keep Open Your Eyes")
        }
        if livenessConfig["setFeedBackCloserMessage"] != nil {
            liveness.setFeedBackCloserMessage(livenessConfig["setFeedBackCloserMessage"] as! String)
        }else{
            liveness.setFeedBackCloserMessage("Move Phone Closer")
        }
        if livenessConfig["setFeedBackCenterMessage"] != nil {
            liveness.setFeedBackCenterMessage(livenessConfig["setFeedBackCenterMessage"] as! String)
        }else{
            liveness.setFeedBackCenterMessage("Center Your Face")
        }
        if livenessConfig["setFeedBackFaceSteadymessage"] != nil {
            liveness.setFeedBackFaceSteadymessage(livenessConfig["setFeedBackFaceSteadymessage"] as! String)
        }else{
            liveness.setFeedbackMultipleFaceMessage("Multiple face detected")
        }
        if livenessConfig["setFeedBackFaceSteadymessage"] != nil {
            liveness.setFeedBackFaceSteadymessage(livenessConfig["setFeedBackFaceSteadymessage"] as! String)
        }else{
            liveness.setFeedBackFaceSteadymessage("Keep Your Head Straight")
        }
        if livenessConfig["setFeedBackLowLightMessage"] != nil {
            liveness.setFeedBackLowLightMessage(livenessConfig["setFeedBackLowLightMessage"] as! String)
        }else{
            liveness.setFeedBackLowLightMessage("Low light detected")
        }
        if livenessConfig["setFeedBackBlurFaceMessage"] != nil {
            liveness.setFeedBackBlurFaceMessage(livenessConfig["setFeedBackBlurFaceMessage"] as! String)
        }else{
            liveness.setFeedBackBlurFaceMessage("Blur detected over face")
        }
        if livenessConfig["setFeedBackGlareFaceMessage"] != nil {
            liveness.setFeedBackGlareFaceMessage(livenessConfig["setFeedBackGlareFaceMessage"] as! String)
        }else{
            liveness.setFeedBackGlareFaceMessage("Glare detected")
        }
        if livenessConfig["setBlurPercentage"] != nil {
            liveness.setBlurPercentage(livenessConfig["setBlurPercentage"] as! Int32)
        }else{
            liveness.setBlurPercentage(80) // set blure percentage -1 to remove this filter
        }
        if livenessConfig["setGlarePercentage_0"] != nil && livenessConfig["setGlarePercentage_1"] != nil{
            liveness.setGlarePercentage(livenessConfig["setGlarePercentage_0"] as! Int32,livenessConfig["setGlarePercentage_1"] as! Int32)
        }else{
            liveness.setGlarePercentage(-1, -1) //set glaremin -1 to remove this filter
        }
        
        
        

        liveness.evaluateServerTrustWIthSSLPinning(false)

        if isLiveness{
            isLiveness = false
            liveness.setLiveness(self)

        }else{
            closeMe()
        }
    }else if isfacematch{
            facematch.setBackGroundColor(faceArgs["backGroundColor"] as! String)
            facematch.setCloseIconColor(faceArgs["closeIconColor"] as! String)
            facematch.setFeedbackBackGroundColor(faceArgs["feedbackBackGroundColor"] as! String)
            facematch.setFeedbackTextColor(faceArgs["feedbackTextColor"] as! String)
            
            if faceArgs["setFeedbackTextSize"] != nil {
                facematch.setFeedbackTextSize((faceArgs["setFeedbackTextSize"] as? Float)!)
            }else{
                facematch.setFeedbackTextSize(Float(18.0))
            }
            if faceArgs["setFeedBackframeMessage"] != nil {
                facematch.setFeedBackframeMessage(faceArgs["setFeedBackframeMessage"] as! String)
            }else{
                facematch.setFeedBackframeMessage("Frame Your Face")
            }
            if faceArgs["setFeedBackAwayMessage"] != nil {
                facematch.setFeedBackAwayMessage(faceArgs["setFeedBackAwayMessage"] as! String)
            }else{
                facematch.setFeedBackAwayMessage("Move Phone Away")
            }
            if faceArgs["setFeedBackOpenEyesMessage"] != nil {
                facematch.setFeedBackOpenEyesMessage(faceArgs["setFeedBackOpenEyesMessage"] as! String)
            }else{
                facematch.setFeedBackOpenEyesMessage("Keep Open Your Eyes")

            }
            if faceArgs["setFeedBackCloserMessage"] != nil {
                facematch.setFeedBackCloserMessage(faceArgs["setFeedBackCloserMessage"] as! String)
            }else{
                facematch.setFeedBackCloserMessage("Move Phone Closer")
            }
            if faceArgs["setFeedBackCenterMessage"] != nil {
                facematch.setFeedBackCenterMessage(faceArgs["setFeedBackCenterMessage"] as! String)
            }else{
                facematch.setFeedBackCenterMessage("Center Your Face")
            }
            if faceArgs["setFeedbackMultipleFaceMessage"] != nil {
                facematch.setFeedbackMultipleFaceMessage(faceArgs["setFeedbackMultipleFaceMessage"] as! String)
            }else{
                facematch.setFeedbackMultipleFaceMessage("Multiple face detected")
            }
            if faceArgs["setFeedBackFaceSteadymessage"] != nil {
                facematch.setFeedBackFaceSteadymessage(faceArgs["setFeedBackFaceSteadymessage"] as! String)
            }else{
                facematch.setFeedBackFaceSteadymessage("Keep Your Head Straight")
            }
            if faceArgs["setFeedBackLowLightMessage"] != nil {
                facematch.setFeedBackFaceSteadymessage(faceArgs["setFeedBackLowLightMessage"] as! String)
            }else{
                facematch.setFeedBackLowLightMessage("Low light detected")
            }
            if faceArgs["setFeedBackBlurFaceMessage"] != nil {
                facematch.setFeedBackBlurFaceMessage(faceArgs["setFeedBackBlurFaceMessage"] as! String)
            }else{
                facematch.setFeedBackBlurFaceMessage("Blur detected over face")
            }
            if faceArgs["setFeedBackGlareFaceMessage"] != nil {
                facematch.setFeedBackGlareFaceMessage(faceArgs["setFeedBackGlareFaceMessage"] as! String)
            }else{
                facematch.setFeedBackGlareFaceMessage("Glare detected")
            }
            if faceArgs["setBlurPercentage"] != nil {
                facematch.setBlurPercentage(faceArgs["setBlurPercentage"] as! Int32)
            }else{
                facematch.setBlurPercentage(80) // set blure percentage -1 to remove this filter
            }
            if faceArgs["setGlarePercentage_0"] != nil && faceArgs["setGlarePercentage_1"] != nil {
                facematch.setGlarePercentage(faceArgs["setGlarePercentage_0"] as! Int32, faceArgs["setGlarePercentage_1"] as! Int32)
            }else{
                facematch.setGlarePercentage(-1, -1)
            }
            
            if isfacematch{
                isfacematch = false

            facematch.setFacematch(self)
            
            }else{
                closeMe()
            }
    }else{
        closeMe()
    }
}
    
    func resizeImage(image: UIImage, targetSize: CGRect) -> UIImage {
       let contextImage: UIImage = UIImage(cgImage: image.cgImage!)
       var newX = targetSize.origin.x - (targetSize.size.width * 0.4)
       var newY = targetSize.origin.y - (targetSize.size.height * 0.4)
       var newWidth = targetSize.size.width * 1.8
       var newHeight = targetSize.size.height * 1.8
       if newX < 0 {
           newX = 0
       }
       if newY < 0 {
           newY = 0
       }
       if newX + newWidth > image.size.width{
           newWidth = image.size.width - newX
       }
       if newY + newHeight > image.size.height{
           newHeight = image.size.height - newY
       }
       let rect = CGRect(x: newX, y: newY, width: newWidth, height: newHeight)
       let imageRef: CGImage = contextImage.cgImage!.cropping(to: rect)!
       let image1: UIImage = UIImage(cgImage: imageRef)
       return image1
   }
    
    func sendError(msg: String) {
        
        self.callBack!([msg as Any, NSNull()])
    }

    @IBAction func baAtn(_ sender: UIButton) {
        closeMe()
    }
}



extension LVController: LivenessData,FacematchData {

    func livenessViewDisappear() {

    }

    func livenessData(_ stLivenessValue: String!, livenessImage: UIImage!, status: Bool) {
        isLiveness = false
        if status == false {
            callBack!(FlutterError.init(code: "101", message: "Failed to get liveness. Please try again", details: nil))
            closeMe()
        }
        var results:[String: Any] = [:]
        self.faceRegion = EngineWrapper.detectSourceFaces(self.faceImage)
        if (faceRegion != nil)
        {
            let face2 = EngineWrapper.detectTargetFaces(livenessImage, feature1: faceRegion?.feature)
            let face11 = faceRegion?.image
            let fm_Score = EngineWrapper.identify(faceRegion?.feature, featurebuff2: face2?.feature)
            if(fm_Score != 0.0){
            let data = face2?.bound
            let image = self.resizeImage(image: livenessImage, targetSize: data!)
                results["detect"] = SwiftOnlyForTrialPlugin.getImageUri(img: image, name: nil)
                results["fm_score"] = SwiftOnlyForTrialPlugin.getImageUri(img: faceImage!, name: nil)
            let twoDecimalPlaces = String(format: "%.2f", fm_Score*100) //Face Match score convert to float value
                results["score"] = stLivenessValue.replacingOccurrences(of: " %", with: "")
                results["face_score"] = twoDecimalPlaces
                self.callBack!(SwiftOnlyForTrialPlugin.convertJSONString(results: results))
                print(twoDecimalPlaces)
                closeMe()
            }
        }
 }
    




    func livenessData(_ stLivenessValue: String!, livenessImage: UIImage!, status: Bool, videoPath: String!, imagePath: String!) {

 }
    
    func facematchViewDisappear() {
        closeMe()
    }
    
    func facematchData(_ FaceImage: UIImage!) {
        isfacematch = false
        var results:[String: Any] = [:]
        self.faceRegion = EngineWrapper.detectSourceFaces(self.faceImage)
        print(faceRegion as Any)
        if (faceRegion != nil)
        {
            let face2 = EngineWrapper.detectTargetFaces(FaceImage, feature1: faceRegion?.feature)
            let face11 = faceRegion?.image
            let fm_Score = EngineWrapper.identify(faceRegion?.feature, featurebuff2: face2?.feature)
            if(fm_Score != 0.0){
            let data = face2?.bound
            let image = self.resizeImage(image: FaceImage, targetSize: data!)
                results["detect"] = SwiftOnlyForTrialPlugin.getImageUri(img: image, name: nil)
            let twoDecimalPlaces = String(format: "%.2f", fm_Score*100) //Face Match score convert to float value
                results["score"] = "\(twoDecimalPlaces)"
                self.callBack!(SwiftOnlyForTrialPlugin.convertJSONString(results: results))
                print(twoDecimalPlaces)
                closeMe()
            }
        }else{
            callBack!(FlutterError.init(code: "101", message: "Failed to get facematch. Please try again", details: nil))
            closeMe()
        }
    }
}
