import 'dart:async';
import 'dart:convert';
import 'dart:ffi';
import 'package:flutter/services.dart';

class OnlyForTrial {
  static const MethodChannel _channel =
  MethodChannel('only_for_trial');


  static Map accuraConfigs = {
    "setCameraFacing":0,
    "setCameraFrame":"",
    "isShowLogo":1,
    "CameraScreen_Navigation_Color":"#D5323F",
    "CameraScreen_Frame_Color":"#D5323F",
    "ACCURA_ERROR_CODE_MOTION" : "Keep Document Steady",
    "ACCURA_ERROR_CODE_DOCUMENT_IN_FRAME":"Keep document in frame",
    "ACCURA_ERROR_CODE_BRING_DOCUMENT_IN_FRAME":"Bring card near to frame",
    "ACCURA_ERROR_CODE_PROCESSING":"Processing...",
    "ACCURA_ERROR_CODE_BLUR_DOCUMENT":"Blur detect in document",
    "ACCURA_ERROR_CODE_FACE_BLUR":"Blur detected over face",
    "ACCURA_ERROR_CODE_GLARE_DOCUMENT":"Glare detect in document",
    "ACCURA_ERROR_CODE_HOLOGRAM":"Hologram Detected",
    "ACCURA_ERROR_CODE_DARK_DOCUMENT":"Low lighting detected",
    "ACCURA_ERROR_CODE_PHOTO_COPY_DOCUMENT":"Can not accept Photo Copy Document",
    "ACCURA_ERROR_CODE_FACE":"Face not detected",
    "ACCURA_ERROR_CODE_MRZ":"MRZ not detected",
    "ACCURA_ERROR_CODE_PASSPORT_MRZ":"Passport MRZ not detected",
    "ACCURA_ERROR_CODE_ID_MRZ":"ID MRZ not detected",
    "ACCURA_ERROR_CODE_VISA_MRZ":"Visa MRZ not detected",
    "ACCURA_ERROR_CODE_UPSIDE_DOWN_SIDE":"Document is upside down. Place it properly",
    "ACCURA_ERROR_CODE_WRONG_SIDE":"Scanning wrong side of Document"
  };

  static Map config = {
    "setFaceBlurPercentage":80,
    "setHologramDetection":true,
    "setLowLightTolerance":10,
    "setMotionThreshold":25,
    "setMinGlarePercentage":6,
    "setMaxGlarePercentage":99,
    "setBlurPercentage":60,
    "setCameraFacing":0,
    "isCheckPhotoCopy":false
  };
  static Map accuraTitleMsg = {
    "SCAN_TITLE_OCR_FRONT":"Scan Front side of ",
    "SCAN_TITLE_OCR_BACK":"Scan Back side of ",
    "SCAN_TITLE_OCR":"Scan ",
    "SCAN_TITLE_MRZ_PDF417_FRONT":"Scan Front Side of Document",
    "SCAN_TITLE_MRZ_PDF417_BACK":"Scan Back Side of Document",
    "SCAN_TITLE_DLPLATE":"Scan Number plate",
    "SCAN_TITLE_BARCODE":"Scan Barcode",
    "SCAN_TITLE_BANKCARD":"Scan BankCard",
  };
  static Map fconfig = {
    "backGroundColor":"#FFC4C4C5",
    "closeIconColor":"#FF000000",
    "feedbackBackGroundColor":"#FFC4C4C5",
    "feedbackTextColor":"#FF000000",
    "setFeedbackTextSize": 18,
    "setFeedBackframeMessage": 'Frame Your Face',
    "setFeedBackAwayMessage": 'Move Phone Away',
    "setFeedBackOpenEyesMessage": 'Keep Your Eyes Open',
    "setFeedBackCloserMessage": 'Move Phone Closer',
    "setFeedBackCenterMessage": 'Move Phone Center',
    "setFeedbackMultipleFaceMessage": 'Multiple Face Detected',
    "setFeedBackFaceSteadymessage": 'Keep Your Head Straight',
    "setFeedBackLowLightMessage":"Low light detected",
    "setFeedBackBlurFaceMessage": 'Blur Detected Over Face',
    "setFeedBackGlareFaceMessage": 'Glare Detected',
    "setBlurPercentage": 80,
    "setGlarePercentage_0": -1,
    "setGlarePercentage_1": -1,
    "feedbackDialogMessage":"Loading...",
    "feedBackProcessingMessage":"Processing...",
    "isShowLogo":1
  };

  static Map lconfig = {
    "backGroundColor":"#FFC4C4C5",
    "closeIconColor":"#FF000000",
    "feedbackBackGroundColor":"#FFC4C4C5",
    "feedbackTextColor":"#FF000000",
    "setFeedbackTextSize": 18,
    "setFeedBackframeMessage": 'Frame Your Face',
    "setFeedBackAwayMessage": 'Move Phone Away',
    "setFeedBackOpenEyesMessage": 'Keep Your Eyes Open',
    "setFeedBackCloserMessage": 'Move Phone Closer',
    "setFeedBackCenterMessage": 'Move Phone Center',
    "setFeedbackMultipleFaceMessage": 'Multiple Face Detected',
    "setFeedBackFaceSteadymessage": 'Keep Your Head Straight',
    "setFeedBackBlurFaceMessage": 'Blur Detected Over Face',
    "setFeedBackGlareFaceMessage": 'Glare Detected',
    "setBlurPercentage": 80,
    "setGlarePercentage_0": -1,
    "setGlarePercentage_1": -1,
    "setLivenessURL": '',
    "setFeedBackLowLightMessage": 'Low light detected',
    "feedbackLowLightTolerence": 39,
    "feedbackDialogMessage":"Loading...",
    "feedBackProcessingMessage":"Processing...",
    "isShowLogo":1
  };


  static Future<void> setLivenessbackGroundColor(String object) async {
    lconfig["backGroundColor"] = object;
  }

  static Future<void> setLivenessfeedbackTextColor(String object) async {
    lconfig["feedbackTextColor"] = object;
  }

  static Future<void> setLivenesscloseIconColor(String object) async {
    lconfig["closeIconColor"] = object;
  }

  static Future<void> setLivenessfeedbackBackGroundColor(String object) async {
    lconfig["feedbackBackGroundColor"] = object;
  }

  static Future<void> isShowLogoLv(int object) async {
    lconfig["isShowLogo"] = object;
  }

  static Future<void> setLivenessfeedBackProcessingMessage(String object) async {
    lconfig["feedBackProcessingMessage"] = object;
  }

  static Future<void> setLivenessfeedbackDialogMessage(String object) async {
    lconfig["feedbackDialogMessage"] = object;
  }

  static Future<void> setLivenessFeedBackLowLightMessage(String object) async {
    lconfig["setFeedBackLowLightMessage"] = object;
  }

  static Future<void> setLivenessURL(String object) async {
    lconfig["setLivenessURL"] = object;
  }

  static Future<void> setLivenessfeedbackLowLightTolerence(int object) async {
    lconfig["feedbackLowLightTolerence"] = object;
  }

  static Future<void> setLivenessGlarePercentage_1(int object) async {
    lconfig["setGlarePercentage_1"] = object;
  }

  static Future<void> setLivenessGlarePercentage_0(int object) async {
    lconfig["setGlarePercentage_0"] = object;
  }

  static Future<void> setLivenessBlurPercentage(int object) async {
    lconfig["setBlurPercentage"] = object;
  }

  static Future<void> setLivenessFeedBackGlareFaceMessage(String object) async {
    lconfig["setFeedBackGlareFaceMessage"] = object;
  }

  static Future<void> setLivenessFeedBackBlurFaceMessage(String object) async {
    lconfig["setFeedBackBlurFaceMessage"] = object;
  }

  static Future<void> setLivenessFeedBackFaceSteadymessage(String object) async {
    lconfig["setFeedBackFaceSteadymessage"] = object;
  }

  static Future<void> setLivenessFeedbackMultipleFaceMessage(String object) async {
    lconfig["setFeedbackMultipleFaceMessage"] = object;
  }

  static Future<void> setLivenessFeedBackCenterMessage(String object) async {
    lconfig["setFeedBackCenterMessage"] = object;
  }

  static Future<void> setLivenessFeedBackCloserMessage(String object) async {
    lconfig["setFeedBackCloserMessage"] = object;
  }

  static Future<void> setLivenessFeedBackOpenEyesMessage(String object) async {
    lconfig["setFeedBackOpenEyesMessage"] = object;
  }

  static Future<void> setLivenessFeedBackAwayMessage(String object) async {
    lconfig["setFeedBackAwayMessage"] = object;
  }

  static Future<void> setLivenessFeedBackframeMessage(String object) async {
    lconfig["setFeedBackframeMessage"] = object;
  }

  static Future<void> setLivenessFeedbackTextSize(int object) async {
    lconfig["setFeedbackTextSize"] = object;
  }




  static Future<void> setFacematchfeedbackTextColor(String object) async {
    fconfig["feedbackTextColor"] = object;
  }

  static Future<void> setFacematchfeedbackBackGroundColor(String object) async {
    fconfig["feedbackBackGroundColor"] = object;
  }

  static Future<void> setFacematchcloseIconColor(String object) async {
    fconfig["closeIconColor"] = object;
  }

  static Future<void> setFacematchbackGroundColor(String object) async {
    fconfig["backGroundColor"] = object;
  }

  static Future<void> isShowLogofm(int object) async {
    fconfig["isShowLogo"] = object;
  }

  static Future<void> setFacematchfeedBackProcessingMessage(String object) async {
    fconfig["feedBackProcessingMessage"] = object;
  }

  static Future<void> setFacematchfeedbackDialogMessage(String object) async {
    fconfig["feedbackDialogMessage"] = object;
  }

  static Future<void> setFaceMatchGlarePercentage_1(int object) async {
    fconfig["setGlarePercentage_1"] = object;
  }

  static Future<void> setFaceMatchGlarePercentage_0(int object) async {
    fconfig["setGlarePercentage_0"] = object;
  }

  static Future<void> setFaceMatchBlurPercentage(int object) async {
    fconfig["setBlurPercentage"] = object;
  }

  static Future<void> setFaceMatchFeedBackGlareFaceMessage(String object) async {
    fconfig["setFeedBackGlareFaceMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackBlurFaceMessage(String object) async {
    fconfig["setFeedBackBlurFaceMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackLowLightMessage(String object) async {
    fconfig["setFeedBackLowLightMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackFaceSteadymessage(String object) async {
    fconfig["setFeedBackFaceSteadymessage"] = object;
  }

  static Future<void> setFaceMatchFeedbackMultipleFaceMessage(String object) async {
    fconfig["setFeedbackMultipleFaceMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackCenterMessage(String object) async {
    fconfig["setFeedBackCenterMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackCloserMessage(String object) async {
    fconfig["setFeedBackCloserMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackOpenEyesMessage(String object) async {
    fconfig["setFeedBackOpenEyesMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackAwayMessage(String object) async {
    fconfig["setFeedBackAwayMessage"] = object;
  }

  static Future<void> setFaceMatchFeedBackframeMessage(String object) async {
    fconfig["setFeedBackframeMessage"] = object;
  }

  static Future<void> setFaceMatchFeedbackTextSize(int object) async {
    fconfig["setFeedbackTextSize"] = object;
  }



  static Future<void> SCAN_TITLE_BANKCARD(String object) async {
    accuraTitleMsg["SCAN_TITLE_BANKCARD"] = object;
  }

  static Future<void> SCAN_TITLE_BARCODE(String object) async {
    accuraTitleMsg["SCAN_TITLE_BARCODE"] = object;
  }

  static Future<void> SCAN_TITLE_DLPLATE(String object) async {
    accuraTitleMsg["SCAN_TITLE_DLPLATE"] = object;
  }

  static Future<void> SCAN_TITLE_MRZ_PDF417_BACK(String object) async {
    accuraTitleMsg["SCAN_TITLE_MRZ_PDF417_BACK"] = object;
  }

  static Future<void> SCAN_TITLE_MRZ_PDF417_FRONT(String object) async {
    accuraTitleMsg["SCAN_TITLE_MRZ_PDF417_FRONT"] = object;
  }

  static Future<void> SCAN_TITLE_OCR(String object) async {
    accuraTitleMsg["SCAN_TITLE_OCR"] = object;
  }

  static Future<void> SCAN_TITLE_OCR_BACK(String object) async {
    accuraTitleMsg["SCAN_TITLE_OCR_BACK"] = object;
  }

  static Future<void> SCAN_TITLE_OCR_FRONT(String object) async {
    accuraTitleMsg["SCAN_TITLE_OCR_FRONT"] = object;
  }



//Camera configs
  static Future<void> setCameraFacing(int object) async {
    config["setCameraFacing"] = object;
    accuraConfigs["setCameraFacing"] = object;
  }

  static Future<void> setBlurPercentage(int object) async {
    config["setBlurPercentage"] = object;
  }

  static Future<void> setMaxGlarePercentage(int object) async {
    config["setMaxGlarePercentage"] = object;
  }

  static Future<void> setMinGlarePercentage(int object) async {
    config["setMinGlarePercentage"] = object;
  }

  static Future<void> setMotionThreshold(int object) async {
    config["setMotionThreshold"] = object;
  }

  static Future<void> setLowLightTolerance(int object) async {
    config["setLowLightTolerance"] = object;
  }

  static Future<void> setHologramDetection(bool object) async {
    config["setHologramDetection"] = object;
  }

  static Future<void> setFaceBlurPercentage(int object) async {
    config["setFaceBlurPercentage"] = object;
  }

  static Future<void> isCheckPhotoCopy(bool object) async {
    config["isCheckPhotoCopy"] = object;
  }



//Error code
  static Future<void> isShowLogo(int object) async {
    accuraConfigs["isShowLogo"] = object;
  }

  // static Future<void> CameraScreen_Frame_Color(String object) async {
  //   accuraConfigs["CameraScreen_Frame_Color"] = object;
  // }
  //
  // static Future<void> CameraScreen_Navigation_Color(String object) async {
  //   accuraConfigs["CameraScreen_Navigation_Color"] = object;
  // }

  static Future<void> ACCURA_ERROR_CODE_WRONG_SIDE(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_WRONG_SIDE"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_UPSIDE_DOWN_SIDE(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_UPSIDE_DOWN_SIDE"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_VISA_MRZ(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_VISA_MRZ"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_ID_MRZ(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_ID_MRZ"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_PASSPORT_MRZ(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_PASSPORT_MRZ"] = object;
  }


  static Future<void> ACCURA_ERROR_CODE_MRZ(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_MRZ"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_FACE(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_FACE"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_PHOTO_COPY_DOCUMENT(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_PHOTO_COPY_DOCUMENT"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_DARK_DOCUMENT(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_DARK_DOCUMENT"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_HOLOGRAM(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_HOLOGRAM"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_GLARE_DOCUMENT(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_GLARE_DOCUMENT"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_FACE_BLUR(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_FACE_BLUR"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_BLUR_DOCUMENT(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_BLUR_DOCUMENT"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_PROCESSING(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_PROCESSING"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_BRING_DOCUMENT_IN_FRAME(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_BRING_DOCUMENT_IN_FRAME"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_DOCUMENT_IN_FRAME(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_DOCUMENT_IN_FRAME"] = object;
  }

  static Future<void> ACCURA_ERROR_CODE_MOTION(String object) async {
    accuraConfigs["ACCURA_ERROR_CODE_MOTION"] = object;
  }

  // static Future<void> setCameraFrame(String object) async {
  //   accuraConfigs["setCameraFrame"] = object;
  //   print("mcniusjx $object");
  // }





  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> getMetaData() async {
    List object = [];
    object.insert(0, config);
    object.insert(1, accuraConfigs);
    object.insert(2, accuraTitleMsg);
    final String result = await _channel.invokeMethod('getMetaData', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> startOcrWithCard(dynamic object) async {
    final String result = await _channel
        .invokeMethod('startOcrWithCard', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> startMRZ(dynamic object) async {
    final String result = await _channel
        .invokeMethod('startMRZ', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> startFaceMatch(List object) async {
    object.insert(1, fconfig);
    final String result = await _channel
        .invokeMethod('startFaceMatch', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> startLiveness(List object) async {
    object.insert(1, lconfig);
    final String result = await _channel
        .invokeMethod('startLiveness', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> startBankCard() async {
    final String result = await _channel
        .invokeMethod('startBankCard',{'arguments':jsonEncode([{"card_name":"Bank Card"}])});
    return result;
  }

  static Future<String> startBarcode(dynamic object) async {
    final String result = await _channel
        .invokeMethod('startBarcode', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> getGallery1(dynamic object) async {
    final String result = await _channel
        .invokeMethod('getGallery1', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> getGallery2(dynamic object) async {
    final String result = await _channel
        .invokeMethod('getGallery2', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> getCamera1(List object) async {
    object.insert(1, fconfig);
    final String result = await _channel.invokeMethod('getCamera1', {'arguments': jsonEncode(object)});
    return result;
  }

  static Future<String> getCamera2(List object) async {
    object.insert(1, fconfig);
    final String result = await _channel.invokeMethod('getCamera2', {'arguments': jsonEncode(object)});
    return result;
  }
}
